﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using DiagramMVVM_UserControls.ViewModels;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;

namespace DiagramMVVM_UserControls
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			this.BindDiagram();
		}

		private void BindDiagram()
		{
			GraphSource source = new GraphSource();
			GridViewViewModel gridModel = new GridViewViewModel(){Position = new Point(0, 200)};
			gridModel.GridItems = new ObservableCollection<string>(){"alpha", "beta", "gamma"};
			TreeViewViewModel treeModel = new TreeViewViewModel() { Position = new Point(300, 50) };
			treeModel.TreeItems = new ObservableCollection<string>() { "tree item A", "tree item B", "tree item C", "tree item D" };
			ProgressBarViewModel progressModel = new ProgressBarViewModel(){ Position = new Point(500, 100)};

			source.AddNode(gridModel);
			source.AddNode(treeModel);
			source.AddNode(progressModel);
			source.AddLink(new LinkViewModelBase<NodeViewModelBase>(gridModel, treeModel));
			source.AddLink(new LinkViewModelBase<NodeViewModelBase>(treeModel, progressModel));


			this.diagram.GraphSource = source;
		}

		private void diagram_ShapeDeserialized_1(object sender, Telerik.Windows.Controls.Diagrams.ShapeSerializationRoutedEventArgs e)
		{
			if (e.SerializationInfo["DataContextType"].ToString() == "ProgressBarViewModel")
			{
				(e.Shape as RadDiagramShape).DataContext = new ProgressBarViewModel();
				(e.Shape as RadDiagramShape).ContentTemplate = this.rootGrid.Resources["progressBarTemplate"] as DataTemplate;
			}
		}

		private void diagram_ShapeSerialized_1(object sender, Telerik.Windows.Controls.Diagrams.ShapeSerializationRoutedEventArgs e)
		{
			if ((e.Shape as RadDiagramShape).DataContext is ProgressBarViewModel)
			{
				e.SerializationInfo["DataContextType"] = "ProgressBarViewModel";
			}
		}
	}
}
