﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using DiagramMVVM_UserControls.ViewModels;

namespace DiagramMVVM_UserControls
{
	public class ShapeTemplateSelector : DataTemplateSelector
	{
		public override System.Windows.DataTemplate SelectTemplate(object item, System.Windows.DependencyObject container)
		{
			if (item is GridViewViewModel)
				return this.GridViewTemplate;
			else if (item is TreeViewViewModel)
				return this.TreeViewTemplate;
			else if (item is ProgressBarViewModel)
				return this.ProgressBarTemplate;

			return base.SelectTemplate(item, container);
		}

		public DataTemplate  GridViewTemplate { get; set; }
		public DataTemplate TreeViewTemplate { get; set; }
		public DataTemplate ProgressBarTemplate { get; set; }

	}
}
